<?php
/***************************************************************************
 *                           admin_mass_pm.php
 *                           -----------------------
 *   Author  		: 	cheesypeanut - Simon Pitfield - cheesypeanut@frogspawn.org
 *   Created 		: 	Friday, August 7, 2004
 *   Modified 		: 	Friday, August 7, 2004
 *
 *   Version		: 	1.0.1
 *
 ***************************************************************************/

define('IN_PHPBB', 1);

if( !empty($setmodules) )
{
	$filename = basename(__FILE__);
	$module['General']['Mass_PM'] = $filename;
	
	return;
}

//
// Load default header
//
$no_page_header = TRUE;
$phpbb_root_path = './../';

require($phpbb_root_path . 'extension.inc');
require('./pagestart.' . $phpEx);

include($phpbb_root_path . 'includes/bbcode.'.$phpEx);
include($phpbb_root_path . 'includes/functions_post.'.$phpEx);
include($phpbb_root_path . 'includes/functions_mass_pm.'.$phpEx);

//
// Increase maximum execution time in case of a lot of users, but don't complain about it if it isn't
// allowed.
//
@set_time_limit(1200);

$message = '';
$subject = '';

//
// Do the job ...
//
if ( isset($HTTP_POST_VARS['submit']) )
{
	$subject = addslashes(trim($HTTP_POST_VARS['subject']));
	$message = addslashes(trim($HTTP_POST_VARS['message']));
	
	$error = FALSE;
	$error_msg = '';

	if ( empty($subject) )
	{
		$error = true;
		$error_msg .= ( !empty($error_msg) ) ? '<br />' . $lang['Empty_subject'] : $lang['Empty_subject'];
	}

	if ( empty($message) )
	{
		$error = true;
		$error_msg .= ( !empty($error_msg) ) ? '<br />' . $lang['Empty_message'] : $lang['Empty_message'];
	}

	$sql = "SELECT user_id 
		FROM " . USERS_TABLE . "
		WHERE user_id <> " . ANONYMOUS . " ORDER BY username ASC";	

	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, 'Could not obtain user information', '', __LINE__, __FILE__, $sql);
	}

	if ( $row = $db->sql_fetchrow($result) )
	{
		$to_user_id = array();
		do
		{
			$to_user_id[] = $row['user_id'];
		}
		while ( $row = $db->sql_fetchrow($result) );

		$db->sql_freeresult($result);
	}

	if ( !$error )
	{
		include($phpbb_root_path . 'includes/emailer.'.$phpEx);

		for ($i = 0; $i < count($to_user_id); $i++)
		{
			insert_pm($to_user_id[$i],$message,$subject,$html_on = 0,$bbcode_on = 1,$smilies_on = 1);
		}

		message_die(GENERAL_MESSAGE, $lang['Message_sent'] . '<br /><br />' . sprintf($lang['Click_return_admin_index'],  '<a href="' . append_sid("index.$phpEx?pane=right") . '">', '</a>'));

	}
}	

if ( $error )
{
	$template->set_filenames(array(
		'reg_header' => 'error_body.tpl')
	);
	$template->assign_vars(array(
		'ERROR_MESSAGE' => $error_msg)
	);
	$template->assign_var_from_handle('ERROR_BOX', 'reg_header');
}

//
// Generate page
//
include('./page_header_admin.'.$phpEx);

$template->set_filenames(array(
	'body' => 'admin/mass_pm_body.tpl')
);

$template->assign_vars(array(
	'MESSAGE' => $message,
	'SUBJECT' => $subject,

	'L_PM_TITLE' => $lang['Mass_pm'],
	'L_PM_EXPLAIN' => $lang['Mass_pm_explain'],
	'L_SUBMIT' => $lang['Submit'],
	'L_COMPOSE' => $lang['Compose'],
	'L_SUBJECT' => $lang['Subject'],
	'L_MSG' => $lang['Message'],

	'S_USER_ACTION' => append_sid('admin_mass_pm.'.$phpEx))

);

$template->pparse('body');

include('./page_footer_admin.'.$phpEx);

?>